
import { _decorator, Component, Node, sp } from 'cc';
const { ccclass, property } = _decorator;

/**
 * Predefined variables
 * Name = NewComponent
 * DateTime = Sat May 14 2022 09:26:55 GMT+0800 (中国标准时间)
 * Author = moxiangyouxi
 * FileBasename = NewComponent.ts
 * FileBasenameNoExtension = NewComponent
 * URL = db://assets/NewComponent.ts
 * ManualUrl = https://docs.cocos.com/creator/3.3/manual/zh/
 *
 */
 
@ccclass('NewComponent')
export class NewComponent extends Component {
    @property(sp.Skeleton)
    skeleton: sp.Skeleton = null;

    start () {
        this.skeleton.setCompleteListener((track) => {
            //开启动作混合后无限回调
            console.log("CompleteListener =", track.animation.name);
            if (track.animation.name == "jump") {
                this.skeleton.setAnimation(0, "idle", true);
            }
        });

        //开启动作混合
        this.skeleton.setMix("jump", "idle", 0.2);
        this.skeleton.setMix("idle", "jump", 0.2);

        this.skeleton.setAnimation(0, "idle", true);
    }

    // update (deltaTime: number) {
    //     // [4]
    // }

    onBtnClick() {
        this.skeleton.setAnimation(0, "jump", false);
    }
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.3/manual/zh/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.3/manual/zh/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.3/manual/zh/scripting/life-cycle-callbacks.html
 */
